name: CodeCov

on: [push, pull_request]

jobs:
  unit-tests:
    # Runs for all supported Django/Python versions
    runs-on: ${{ matrix.os }}
    strategy:
      fail-fast: false
      matrix:
        python-version: ['3.8', '3.9', '3.10', '3.11']
        django-version: ['3.2', '4.0', '4.1', '4.2']
        os: [
          ubuntu-20.04,
        ]
        exclude:
          - python-version: '3.11'
            django-version: '3.2'
          - python-version: '3.11'
            django-version: '4.0'
          - python-version: '3.8'
            django-version: '4.2'
          - python-version: '3.9'
            django-version: '4.2'

    steps:
    - uses: actions/checkout@v3
    - name: Set up Python ${{ matrix.python-version }}

      uses: actions/setup-python@v4
      with:
        python-version: ${{ matrix.python-version }}
    - name: Install dependencies
      run: |
        python -m pip install --upgrade pip
        pip install Django==${{ matrix.django-version }} coverage
        python setup.py install

    - name: Run coverage
      run: coverage run setup.py test

    - name: Upload Coverage to Codecov
      uses: codecov/codecov-action@v3


  unit-tests-future-versions:
    # Runs for all Django/Python versions which are not yet supported
    runs-on: ${{ matrix.os }}
    strategy:
      fail-fast: false
      matrix:
        python-version: ['3.10', '3.11']
        django-version: [
          'https://github.com/django/django/archive/main.tar.gz'
        ]
        os: [
          ubuntu-20.04,
        ]

    steps:
    - uses: actions/checkout@v3
    - name: Set up Python ${{ matrix.python-version }}

      uses: actions/setup-python@v4
      with:
        python-version: ${{ matrix.python-version }}
    - name: Install dependencies
      run: |
        python -m pip install --upgrade pip
        pip install ${{ matrix.django-version }} coverage
        python setup.py install

    - name: Run coverage
      run: coverage run setup.py test
      continue-on-error: true

    - name: Upload Coverage to Codecov
      uses: codecov/codecov-action@v3
